#include <string.h>
#include <lua.hpp>

using namespace std;

class TestClass
{
private:
	double valueA,valueB;
	// fobOp֐
	void output();
public:
	TestClass();
	~TestClass();
	void setValue(double argA,double argB);
	void getValue(double* dst);
}

TestClass::TestClass()
	:valueA(0),valueB(0)
{
	printf_s("TestClass instantiated\n\n");
	this->output();
}

TestClass::~TestClass()
{
	this->output();
	printf_s("TestClass destroyed");
}

void TestClass::setValue(double argA,double argB)
{
	this->valueA=argA;
	this->valueB=argB;
	this->output();
}

void TestClass::getValue(double* dst)
{
	dst[0]=this->valueA;
	dst[1]=this->valueB;
	this->output();
}

void TestClass::output()
{
	printf_s("valueA = %f\nvalueB = %f\n\n",this->valueA,this->valueB);
}

// O[R[h

int lua_TestClass_delete(lua_State* L)
{
	TestClass* object=*(TestClass**)lua_touserdata(L,1);
	delete object;
	return 0;
}

int lua_TestClass_setValue(lua_State* L)
{
	TestClass* object=*(TestClass**)lua_touserdata(L,1);
	object->setValue(lua_tonumber(L,-2),lua_tonumber(L,-1));
	return 0;
}

int lua_TestClass_getValueT(lua_State* L)
{
	TestClass* object=*(TestClass**)lua_touserdata(L,1);
	double temp[]={0,0};
	object->getValue(temp);
	lua_newtable(L);
	lua_pushnumber(L,temp[0]);
	lua_pushnumber(L,temp[1]);
	lua_setfield(L,2,"valueB");
	lua_setfield(L,2,"valueA");
	return 1;
}

int lua_TestClass_getValueE(lua_State* L)
{
	TestClass* object=*(TestClass**)lua_touserdata(L,1);
	double temp[]={0,0};
	object->getValue(temp);
	lua_pushnumber(L,temp[0]);
	lua_pushnumber(L,temp[1]);
	return 2;
}

int lua_TestClass(lua_State* L)
{
	// X^bNɃ[Uf[^^ƂTextClassIuWFNg̃|C^vbV
	TestClass** object=(TestClass**)lua_newuserdata(L,sizeof(TestClass*));
	*object=new TestClass();

	// ֐o^邽߂̃e[uƃ^e[û߂̃e[uvbV
	lua_newtable(L);
	lua_newtable(L);

	// e[uɊ֐o^itB[h:֐Cl:֐|C^j
	lua_pushcfunction(L,lua_TestClass_delete);
	lua_setfield(L,3,"delete");
	lua_pushcfunction(L,lua_TestClass_getValueT);
	lua_setfield(L,3,"getValueT");
	lua_pushcfunction(L,lua_TestClass_getValueE);
	lua_setfield(L,3,"getValueE");
	lua_pushcfunction(L,lua_TestClass_setValue);
	lua_setfield(L,3,"setValue");

	// ֐o^e[u[Uf[^^̃^e[uƂăZbg
	lua_setfield(L,2,"__index");
	lua_setmetatable(L,1);

	// [Uf[^^iTextClassj̃|C^^[iX^bNgbṽIuWFNg1j
	return 1;
}

int main()
{
	lua_State* L=luaL_newstate();
	luaL_openlibs(L);
	lua_register(L,"TestClass",lua_TestClass);
	luaL_dofile(L,"Sample.lua");
	lua_close(L);
	getchar();
	return 0;
}
